const { MessageEmbed, MessageActionRow, MessageButton, Client, MessageSelectMenu } = require('discord.js');



// Discord Client 
class $client extends Client {

  constructor(data) {

    super(data);

  }

  

}
// Discord Client End

// Discord Message Event
const { Message } = require('discord.js');

class $message extends Message {

  constructor(data, client) {

    super(client, data, null);

  }
}
  async function $sendMessage(content, channel) {

    const message = await channel.send(content);

    return message;

  }
//Discord Message Event End

// Client Events
function $clientEvent(client, eventName, eventFunction) {
  if (!(client instanceof Client)) {
    throw new TypeError('client must be a Client object.');
  }

  if (typeof eventName !== 'string') {
    throw new TypeError('eventName must be a string.');
  }

  if (typeof eventFunction !== 'function') {
    throw new TypeError('eventFunction must be a function.');
  }

  client.on(eventName, eventFunction);
}
// Client Events End


// Embed Builder Function
class $embed {
  constructor(channel) {
    this.channel = channel;
      
    this.embed = new MessageEmbed();
    
  }

    
  title(title) {
    this.embed.setTitle(title);
    return this;
  }

  description(description) {
    this.embed.setDescription(description);
    return this;
  }

  URL(url) {
    this.embed.setURL(url);
    return this;
  }

  color(color) {
    this.embed.setColor(color);
    return this;
  }

  author(name, iconURL, url) {
    this.embed.setAuthor(name, iconURL, url);
    return this;
  }

  thumbnail(url) {
    this.embed.setThumbnail(url);
    return this;
  }

  field(name, value, inline = false) {
    this.embed.addField(name, value, inline);
    return this;
  }

  fields(...fields) {
    this.embed.addFields(...fields);
    return this;
  }

  image(url) {
    this.embed.setImage(url);
    return this;
  }

  footer(text, iconURL) {
    this.embed.setFooter(text, iconURL);
    return this;
  }

  timestamp(timestamp = Date.now()) {
    this.embed.setTimestamp(timestamp);
    return this;
  }

  send() {
    this.channel.send({ embeds: [this.embed] });
  }
    
 sendWithRow(...buttons) {
this.channel.send({ embeds: [this.embed], components: [new MessageActionRow().addComponents(...buttons)]})
    
     }
  }   
 // Embed Builder Function End  
    
    







 









// Button Builder Function
class $button {
  constructor() {
      
   this.button = new MessageButton();
      
  }
customId(id) {

    this.button.setCustomId(id);
return this
  }

  label(label) {

    this.button.setLabel(label);
return this
  }

  style(style) {

    this.button.setStyle(style);
return this
  }

  disabled(disabled) {

  this.button.setDisabled(disabled);
return this
  }

  emoji(emoji) {

    this.button.setEmoji(emoji);
return this
  }

  url(url) {

  this.button.setURL(url);
return this
  }
  
save() {
    const buton = this.button
    return buton
}
  
}
// Button Builder Function End





  

  

  
  
// Select Menu Builder Function
class $selectMenu {
  constructor() {
    this.menu = new MessageSelectMenu();
  }

  customId(customId) {
    this.menu.setCustomId(customId);
    return this;
  }

placeholder(label) {

    this.menu.setPlaceholder(label)

    return this;

  }
 
options(...options) {

    this.menu.addOptions([...options]);

    return this;

  }
  
    
    
    save() {
        const menu = this.menu
        return menu;
    }
    
}
// Select Menu Builder Function
 

// Slash Command Builder Function
const { SlashCommandBuilder } = require('@discordjs/builders');

class $slashCommand {
    constructor() {

    this.slash = new SlashCommandBuilder();

  }
  name(name) {
     this.slash.setName(name);
      return this;
  }

  description(description) {
     this.slash.setDescription(description);
      return this;
  }

  stringOption(name, description, required = false) {
   this.slash.addStringOption(option => option.setName(name).setDescription(description).setRequired(required));
      return this;
  }

  integerOption(name, description, required = false) {
    this.slash.addIntegerOption(option => option.setName(name).setDescription(description).setRequired(required));
      return this;
  }

  booleanOption(name, description, required = false) {
  this.slash.addBooleanOption(option => option.setName(name).setDescription(description).setRequired(required));
      return this;
  }

  userOption(name, description, required = false) {
   this.slash.addUserOption(option => option.setName(name).setDescription(description).setRequired(required));
      return this;
  }

  channelOption(name, description, required = false) {
    this.slash.addChannelOption(option => option.setName(name).setDescription(description).setRequired(required));
      return this;
  }

  roleOption(name, description, required = false) {
   this.slash.addRoleOption(option => option.setName(name).setDescription(description).setRequired(required));
      return this;
  }

  mentionableOption(name, description, required = false) {
    this.slash.addMentionableOption(option => option.setName(name).setDescription(description).setRequired(required));
      return this;
  }

  subcommand(subcommand) {
   this.slash.addSubcommand(subcommand);
      return this;
  }

  subcommandGroup(subcommandGroup) {
    this.slash.addSubcommandGroup(subcommandGroup);
      return this;
  }
    
  toJSON() {

    return this.slash.toJSON();

  }
    type(type) {

    this.slash.setType(type);

    return this;

  }
    
}
// Slash Command Builder End


    


module.exports = { $message, $embed, $client, $sendMessage, $clientEvent, $button, $selectMenu, $slashCommand }